VERSION 2.00
Begin Form frmGetFile 
   Caption         =   "Select File"
   ClientHeight    =   4020
   ClientLeft      =   435
   ClientTop       =   1485
   ClientWidth     =   8835
   Height          =   4425
   Left            =   375
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4020
   ScaleWidth      =   8835
   Top             =   1140
   Width           =   8955
   Begin CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   495
      Left            =   7320
      TabIndex        =   11
      Top             =   2160
      Width           =   1215
   End
   Begin CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   495
      Left            =   7320
      TabIndex        =   10
      Top             =   1560
      Width           =   1215
   End
   Begin FileListBox filFiles 
      Height          =   1395
      Left            =   3000
      TabIndex        =   8
      Top             =   1320
      Width           =   2055
   End
   Begin TextBox txtFileName 
      Height          =   285
      Left            =   3000
      TabIndex        =   7
      Top             =   960
      Width           =   2055
   End
   Begin DirListBox dirDirectory 
      Height          =   1605
      Left            =   5160
      TabIndex        =   4
      Top             =   1080
      Width           =   1935
   End
   Begin ComboBox cboFiletype 
      Height          =   300
      Left            =   3000
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   3120
      Width           =   2055
   End
   Begin DriveListBox drvDrive 
      Height          =   315
      Left            =   5160
      TabIndex        =   0
      Top             =   3120
      Width           =   1935
   End
   Begin Image Image1 
      Height          =   3255
      Left            =   240
      Picture         =   GETFILE.FRX:0000
      Stretch         =   -1  'True
      Top             =   360
      Width           =   2535
   End
   Begin Label lblDirName 
      Height          =   255
      Left            =   5160
      TabIndex        =   9
      Top             =   720
      Width           =   3615
   End
   Begin Label lblFileName 
      Caption         =   "File Name:"
      Height          =   255
      Left            =   3000
      TabIndex        =   6
      Top             =   600
      Width           =   1215
   End
   Begin Label lblDirectories 
      Caption         =   "Directories:"
      Height          =   255
      Left            =   5160
      TabIndex        =   5
      Top             =   360
      Width           =   1215
   End
   Begin Label lblFileType 
      Caption         =   "File Type:"
      Height          =   255
      Left            =   3000
      TabIndex        =   3
      Top             =   2880
      Width           =   1215
   End
   Begin Label lblDrive 
      Caption         =   "Drive:"
      Height          =   255
      Left            =   5160
      TabIndex        =   1
      Top             =   2880
      Width           =   1215
   End
End
Option Explicit

Sub cboFiletype_Click ()
    Dim PatternPos1 As Integer
    Dim PatternPos2 As Integer
    Dim PatternLen As Integer
    Dim Pattern As String

    ' Find the starting position of the pattern
    ' in the cboFileType combo box.
    PatternPos1 = InStr(1, cboFileType.Text, "(") + 1

    ' Find the end position of the pattern
    ' in the cboFileType combo box.
    PatternPos2 = InStr(1, cboFileType.Text, ")") + 1

    ' Calculate the length of the Pattern string
    PatternLen = PatternPos2 - PatternPos1 + 1

    ' Extract the Pattern position of the cboFileType
    ' combo box.
    Pattern = Mid$(cboFileType.Text, PatternPos1, PatternLen)

    ' Set the Pattern of the filFiles file listbox
    ' to the selected pattern.
    filFiles.Pattern = Pattern

End Sub

Sub cmdCancel_Click ()

    ' Set the Tag property of the frmGetFile form
    ' to null.
    frmGetFile.Tag = ""

    ' Hide the frmGetFile form
    frmGetFile.Hide

End Sub

Sub cmdOK_Click ()

    Dim PathAndName As String
    Dim Path

    ' If no file is selected then inform the user
    ' and exit this pricedure.
    If txtFileName.Text = "" Then
       MsgBox "No file is selected!", 48, "Error"
       Exit Sub
    End If

    ' Make sure that Path ends with backslash \
    If Right$(filFiles.Path, 1) <> "\" Then
       Path = filFiles.Path + "\"
    Else
       Path = filFiles.Path
    End If

    ' Extract the Path and Name of the selected file.
    If txtFileName.Text = filFiles.FileName Then
       PathAndName = Path + filFiles.FileName
    Else
       PathAndName = txtFileName
    End If


    ' Set the Tag property of the frmGetFile
    ' dialog box to the selected file path and name.
    frmGetFile.Tag = PathAndName

    ' Hide the frmGetFile form
    frmGetFile.Hide


End Sub

Sub dirDirectory_Change ()

    ' A new directory was selected by
    ' the user.
    ' Update the path of the file list box
    ' accordingly.
    filFiles.Path = dirDirectory.Path

    ' Update the lblDirName label.
    lblDirName.Caption = dirDirectory.Path

End Sub

Sub drvDrive_Change ()

    ' Set an error trap
    On Error GoTo DriveError

    ' Set the Path of the directory list to
    ' the new drive.
    dirDirectory.Path = drvDrive.Drive
    Exit Sub


DriveError:
     ' An error occurred!
     ' Tell the user the nature of the error
     MsgBox "Drive error!", 48, "Error"

     ' Restore the original drive
     drvDrive = dirDirectory.Path
     Exit Sub

End Sub

Sub filFiles_Click ()

    ' Update the txtFileName text box with
    ' the filename that was selected.
    txtFileName = filFiles.FileName

End Sub

Sub filFiles_DblClick ()

    ' Update the txtFileName text box with
    ' the filename that was double-clicked.
    txtFileName = filFiles.FileName

    ' Execute the cmdOK_Click() procedure
    cmdOK_Click


End Sub

Sub Form_Load ()

    ' Set the caption of the lblDirName label
    ' with the path of the directory

    lblDirName.Caption = dirDirectory.Path

End Sub

